library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.util.all;
use work.simeck_pkg.all;
----------------------------------------------------
entity fsm is
  port
    ( clk,
      reset             	:in std_logic;     
      o_cont                :out unsigned (reg_rounds -1 downto 0);
	  o_cont_steps          :out unsigned (reg_steps -1 downto 0)
      );
end entity;

architecture main of fsm is
   
  signal  cont             : unsigned(reg_rounds -1  downto 0);  --used to control which internal round

  signal cont_steps        : unsigned(reg_steps -1 downto 0);   -- used to control the outside steps
  

begin

  process
   begin
    wait until rising_edge(clk);
    if reset ='1'  then
      cont <= (others => '0');
    else
      cont <= cont + 1 ;
    end if;
  end process;

  
  process
   begin
    wait until rising_edge(clk);
    if reset ='1' then
      cont_steps <= (others => '0');
    elsif (cont = 7) then
      cont_steps <= cont_steps + 1 ;
    elsif (cont_steps = 18 ) then
      cont_steps <= cont_steps;
    end if;
  end process;

   
  o_cont   <= cont;
  o_cont_steps <= cont_steps;	
end architecture;	 














