
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.simeck_pkg.all;

entity simeck is
  port(
    clk                  : in std_logic;
    reset                : in std_logic;
    mode                 : in std_logic;
    data_block           : in block_elem;
    message_in           : in std_logic_vector(63 downto 0);
    message_in2          : in std_logic_vector(2 downto 0);
    message_out          : out std_logic_vector(63 downto 0);
    encoding_message     : out block_elem
    );
end entity;

------------------------------------------------------------------------
architecture main of simeck is
  
  signal cont_irounds    :  unsigned (reg_rounds -1 downto 0);
  signal cont_steps      :  unsigned (reg_steps -1 downto 0);
  
begin

  --------------------------------------------------------------    
  fsm : entity work.fsm
    port map	  
    ( clk                   =>  clk
     ,reset                 =>  reset
     ,o_cont                =>  cont_irounds
	 ,o_cont_steps          =>  cont_steps
     );	
  
  --------------------------------------------------------------
  dp :  entity work.dp
    port map
    (clk                    => clk
     ,reset                 => reset
     ,mode                  => mode
     ,data_block            => data_block
     ,cont_irounds          => cont_irounds
     ,cont_steps            => cont_steps
     ,message_in            => message_in
     ,message_in2           => message_in2
     ,message_out           => message_out	 
     ,encoding_message      => encoding_message
    );
  
  
end architecture;
