library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.simeck_pkg.all;

entity simeck_tb is
  generic(
  period      : real := 10.0  
 -- hold_delay  : real  := 0.2
);  
end entity;

architecture main of simeck_tb is
  
  --------------------------------------------------------------
  -- constant period        : real    := 10000.0;
  constant hold_delay    : real    := 0.2;
  constant clk_period    : time    := period * 1 ns;
  ---------------------------------------------------------
  signal clk                   : std_logic;
  signal reset                 : std_logic;
  

  signal encoding_message      : block_elem;
  signal data_block :block_elem;

  constant data1               :block_elem:= (x"ffffffff",x"ffffffff",x"ffffffff",x"ffffffff",x"ffffffff",x"ffffffff"
,x"ffffffff",x"ffffffff");
 
begin 

  process begin
    clk <= '0';
    wait for 0.5 * clk_period;
    loop
      clk <= '0';
      wait for 0.5 * clk_period;
      clk <= '1';
      wait for 0.5 * clk_period;
    end loop;
  end process;
  
  uut: entity work.simeck
    port map 
    (reset             => reset
     ,clk              => clk
     ,data_block       => data_block
     ,encoding_message => encoding_message
     );	
  
  
  process
  begin	   
   
    reset   <='0';
    wait until rising_edge(clk);
    wait for (2.0 + hold_delay) * clk_period;   
    wait for 3 * clk_period;
    
    reset <='1';   
    data_block <= data1;
    wait for clk_period;
    wait for hold_delay * clk_period;

     reset <= '0';

    --for i in 0 to 108 loop
	   for i in 0 to 108 loop
        wait until rising_edge(clk);
    end loop;

    report( "done the first data, encoding message: ");

    wait;
    
  end process;  

end architecture main;
