
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.simeck_pkg.all;

entity spoc is
  port(
    clk                  : in std_logic;
    reset                : in std_logic;
     mode                : in std_logic;
    data_block           : in block_elem;
    message_in           : in std_logic_vector(31 downto 0); 
    message_in2          : in std_logic_vector(2 downto 0);
    message_out          : out std_logic_vector(31 downto 0);
     encoding_message     : out block_elem
    );
end entity;

------------------------------------------------------------------------
architecture main of spoc is
  
  signal cont_irounds    :  unsigned (reg_rounds -1 downto 0);
  signal cont_steps      :  unsigned (reg_steps -1 downto 0);
  signal data_block_tmp, encoding_message_tmp  : block_elem;
begin

 
 data_block_tmp(0) <= data_block (0) when mode ='0' else
                      encoding_message_tmp(0) xor message_in(23 downto 0) ;
  data_block_tmp(1)(7 downto 0) <= data_block(1)(7 downto 0) when mode ='0' else
                                   encoding_message_tmp(1)(7 downto 0) xor message_in(31 downto 24);
 data_block_tmp(1)(23 downto 8 ) <= data_block(1)(23 downto 8 ) when mode ='0' else
                                    encoding_message_tmp(1)(23 downto 8);


  data_block_tmp(oblock_num -2 downto 2) <= data_block(oblock_num-2 downto 2) when mode='0' else
                                            encoding_message_tmp(oblock_num-2 downto 2);
  data_block_tmp(oblock_num-1)(word_sz-1 downto word_sz-4) <=  data_block(oblock_num-1)(word_sz-1 downto word_sz-4) when mode='0' else
         encoding_message_tmp(oblock_num-1)(word_sz-1 downto word_sz-4) xor message_in2;
   data_block_tmp(oblock_num-1)(word_sz-5 downto 0) <=  data_block(oblock_num-1)(word_sz-5 downto 0) when mode ='0' else
  encoding_message_tmp(oblock_num-1)(word_sz-5 downto 0);
encoding_message_tmp(oblock_num-1) <= data_block_tmp(oblock_num-1)xor message_in(23 downto 0);
encoding_message_tmp(oblock_num-2)(7 downto 0) <= data_block_tmp(oblock_num-2)(7 downto 0)xor message_in(31 downto 24);
----------------------------------
  simeck :  entity work.simeck
    port map
    (clk                    => clk
     ,reset                 => reset
     ,mode                  => mode
     ,data_block            => data_block
     ,cont_irounds          => cont_irounds
     ,cont_steps            => cont_steps	 
     ,message_in           => message_in
     ,message_in2          => message_in2
     ,message_out          => message_out
     ,encoding_message      => encoding_message
    );
  encoding_message <= encoding_message_tmp;
  
end architecture;
