library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package util is
  -----------------------------------------------------
  function int_log( n, base : natural ) return natural;
  function int_log2( n : natural ) return natural;
  -----------------------------------------------------
  function max2(m: natural; n: natural) return natural;
  -----------------------------------------------------
  --function "srl" (v : std_logic_vector; n : natural) return std_logic_vector;
  --function "sll" (v : std_logic_vector; n : natural) return std_logic_vector;
  --function "rol" (v : std_logic_vector; n : natural) return std_logic_vector;
  --function "ror" (v : std_logic_vector; n : natural) return std_logic_vector;
  -----------------------------------------------------
end package;

package body util is

  --------------------------------------------------------------
  function int_log( n, base : natural ) return natural is
  begin
    if n <= base then
      return 1;
    else
      return (1 + int_log( n / base, base ));
    end if;
  end function;

  function int_log2( n : natural ) return natural is
  begin
  
    if n=32 then
	   return 5;
    elsif n = 36 or n= 42 or n= 44 or n= 52 or n= 54 or n= 64 or n= 48 or n= 45  then
       return 6;
    elsif n= 68 or n= 69 or n=72 or n= 96 or n=128  then
       return 7;
    elsif n= 256 or n= 144 or n= 192 then
       return 8; 
    else
       return int_log( n, 2 );
    end if;
  end function;


 

  --------------------------------------------------------------
  function max2( m: natural; n: natural ) return natural is
  begin
      if m >= n then
        return m;
      else
        return n;
      end if;
  end function;
  --------------------------------------------------------------
 -- function "srl" ( v : std_logic_vector; n : natural )
 --   return std_logic_vector
 -- is
 -- begin
 --   return std_logic_vector( unsigned(v) srl n );
 -- end function;
  
  --------------------------------------------------------------
  --function "sll" ( v : std_logic_vector; n : natural )
  --  return std_logic_vector
 -- is
 -- begin
 --   return std_logic_vector( unsigned(v) sll n );
 -- end function;
  
  --------------------------------------------------------------
 -- function "rol" (v : std_logic_vector; n : natural) 
 --   return std_logic_vector
 -- is
 -- begin
 --   return std_logic_vector( unsigned(v) rol n );
 -- end function;
  
  --------------------------------------------------------------
 -- function "ror" (v : std_logic_vector; n : natural)
 --   return std_logic_vector
 -- is
 -- begin
 --   return std_logic_vector( unsigned(v) ror n );
 -- end function;
  
  --------------------------------------------------------------

end package body;  
